rm(list=ls())


library(mnormt)
library(survival)



############################
##complete case analysis####
############################

##caculate density
calden=function(Xi.den,Yi.den,Ti.den,obsti.den,Sigma.den,inverSigma.den,mi.den,beta.den,zeta.den,mu.den){  
  difti=Ti.den-obsti.den
  if (mi.den>1){Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)}
  if (mi.den==1) {Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))}
  ri=Yi.den-Xnewi%*%beta.den
  f=exp(-0.5*log(abs(det(as.matrix(Sigma.den))))-0.5*t(ri)%*%inverSigma.den%*%ri-mi.den/2*log(2*pi))
  return(f)  
}

##caculate density
callogden=function(Xi.den,Yi.den,Ti.den,obsti.den,Sigma.den,inverSigma.den,mi.den,beta.den,zeta.den,mu.den){  
  difti=Ti.den-obsti.den
  if (mi.den>1){Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)}
  if (mi.den==1) {Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))}
  ri=Yi.den-Xnewi%*%beta.den
  f=(-0.5*log(abs(det(as.matrix(Sigma.den))))-0.5*t(ri)%*%inverSigma.den%*%ri-mi.den/2*log(2*pi))
  return(f)  
}



##caculate dlogfdm
caldlogfdm=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,mi.den,beta.den,zeta.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){
    p=dim(Xi.den)[2]
    Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)
    G=cbind(rep(0,mi.den),exp(-(difti-mu.den)^2*(zeta.den))*(2*(difti-mu.den)*zeta.den),matrix(rep(0,mi.den*p),nrow=mi.den))
  }
  if (mi.den==1) {
    p=length(Xi.den)
    Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))
    G=t(c(0,exp(-(difti-mu.den)^2*(zeta.den))*(2*(difti-mu.den)*zeta.den),rep(0,p)))
  }
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(-2*t(beta.den)%*%t(G)%*%inverSigma.den%*%ri)
  return(f)	
}

##caculate dlogfdb
caldlogfdb=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,mi.den,beta.den,zeta.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)}
  if (mi.den==1) {Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))}
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(-2*t(Xnewi)%*%inverSigma.den%*%ri)
  return(f)	
}
##caculate dlogfdthe1
caldlogfdthe1=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,mi.den,beta.den,zeta.den,A1.den,dsigma1.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)}
  if (mi.den==1) {Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))}
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(-t(ri)%*%A1.den%*%ri)-0.5*sum(diag(inverSigma.den%*%dsigma1.den))
  return(f)	
}
##caculate dlogfdz
caldlogfdz=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,A1.den,dsigma1.den,mi.den,beta.den,zeta.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){
    p=dim(Xi.den)[2]
    Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)
    E=cbind(rep(0,mi.den),exp(-(difti-mu.den)^2*(zeta.den))*(-(difti-mu.den)^2),matrix(rep(0,mi.den*p),nrow=mi.den))
  }
  if (mi.den==1) {
    p=length(Xi.den)
    Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))
    E=t(c(0,exp(-(difti-mu.den)^2*(zeta.den))*(-(difti-mu.den)^2),rep(0,p)))
  }
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(-2*t(beta.den)%*%t(E)%*%inverSigma.den%*%ri)
  return(f)	
}

##caculate dlogfdbdb
caldlogfdbdb=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,mi.den,beta.den,zeta.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)}
  if (mi.den==1) {Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))}
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(2*t(Xnewi)%*%inverSigma.den%*%Xnewi)
  return(f)	
}
##caculate dlogfdthe1dthe1
caldlogfdthe1dthe1=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,mi.den,beta.den,zeta.den,dA11.den,A1.den,dsigma1.den,dsigma11.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)}
  if (mi.den==1) {Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))}
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(-t(ri)%*%dA11.den%*%ri)-0.5*sum(diag(-t(A1.den)%*%dsigma1.den+inverSigma.den%*%dsigma11.den))
  return(f)	
}

##caculate dlogfdthe1db
caldlogfdthe1db=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,mi.den,beta.den,zeta.den,A1.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)}
  if (mi.den==1) {Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))}
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(t(Xnewi)%*%(A1.den+t(A1.den))%*%ri)
  return(f)	
}

##caculate dlogfdzdz
caldlogfdzdz=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,A1.den,dsigma1.den,mi.den,beta.den,zeta.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){
    p=dim(Xi.den)[2]
    Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)
    E=cbind(rep(0,mi.den),exp(-(difti-mu.den)^2*(zeta.den))*(-(difti-mu.den)^2),matrix(rep(0,mi.den*p),nrow=mi.den))
    F=cbind(rep(0,mi.den),exp(-(difti-mu.den)^2*(zeta.den))*((difti-mu.den)^4),matrix(rep(0,mi.den*p),nrow=mi.den))
  }
  if (mi.den==1) {
    p=length(Xi.den)
    Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))
    E=t(c(0,exp(-(difti-mu.den)^2*(zeta.den))*(-(difti-mu.den)^2),rep(0,p)))
    F=t(c(0,exp(-(difti-mu.den)^2*(zeta.den))*((difti-mu.den)^4),rep(0,p)))
  }
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(-2*(t(beta.den)%*%t(F)%*%inverSigma.den%*%ri-t(beta.den)%*%t(E)%*%inverSigma.den%*%E%*%beta.den))
  return(f)	
}
##caculate dlogfdzdb
caldlogfdzdb=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,A1.den,dsigma1.den,mi.den,beta.den,zeta.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){
    p=dim(Xi.den)[2]
    Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)
    E=cbind(rep(0,mi.den),exp(-(difti-mu.den)^2*(zeta.den))*(-(difti-mu.den)^2),matrix(rep(0,mi.den*p),nrow=mi.den))
  }
  if (mi.den==1) {
    p=length(Xi.den)
    Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))
    E=t(c(0,exp(-(difti-mu.den)^2*(zeta.den))*(-(difti-mu.den)^2),rep(0,p)))
  }
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(-2*t(E)%*%inverSigma.den%*%ri+2*t(t(beta.den)%*%t(E)%*%inverSigma.den%*%Xnewi))
  return(f)	
}

##caculate dlogfdzdthe1
caldlogfdzdthe1=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,mi.den,beta.den,zeta.den,A1.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){
    p=dim(Xi.den)[2]
    Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)
    E=cbind(rep(0,mi.den),exp(-(difti-mu.den)^2*(zeta.den))*(-(difti-mu.den)^2),matrix(rep(0,mi.den*p),nrow=mi.den))
  }
  if (mi.den==1) {
    p=length(Xi.den)
    Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))
    E=t(c(0,exp(-(difti-mu.den)^2*(zeta.den))*(-(difti-mu.den)^2),rep(0,p)))
  }
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(2*t(beta.den)%*%t(E)%*%A1.den%*%ri)
  return(f)	
}


##caculate dlogfdmdm
caldlogfdmdm=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,A1.den,dsigma1.den,mi.den,beta.den,zeta.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){
    p=dim(Xi.den)[2]
    Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)
    G=cbind(rep(0,mi.den),exp(-(difti-mu.den)^2*(zeta.den))*(2*(difti-mu.den)*zeta.den),matrix(rep(0,mi.den*p),nrow=mi.den))
    H=cbind(rep(0,mi.den),exp(-(difti-mu.den)^2*(zeta.den))*(4*zeta.den^2*(difti-mu.den)^2-2*zeta.den),matrix(rep(0,mi.den*p),nrow=mi.den))
  }
  if (mi.den==1) {
    p=length(Xi.den)
    Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))
    G=t(c(0,exp(-(difti-mu.den)^2*(zeta.den))*(2*(difti-mu.den)*zeta.den),rep(0,p)))
    H=t(c(0,exp(-(difti-mu.den)^2*(zeta.den))*(4*zeta.den^2*(difti-mu.den)^2-2*zeta.den),rep(0,p)))
  }
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(-2*(t(beta.den)%*%t(H)%*%inverSigma.den%*%ri-t(beta.den)%*%t(G)%*%inverSigma.den%*%G%*%beta.den))
  return(f)	
}

##caculate dlogfdmdb
caldlogfdmdb=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,A1.den,dsigma1.den,mi.den,beta.den,zeta.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){
    p=dim(Xi.den)[2]
    Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)
    G=cbind(rep(0,mi.den),exp(-(difti-mu.den)^2*(zeta.den))*(2*(difti-mu.den)*zeta.den),matrix(rep(0,mi.den*p),nrow=mi.den))
  }
  if (mi.den==1) {
    p=length(Xi.den)
    Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))
    G=t(c(0,exp(-(difti-mu.den)^2*(zeta.den))*(2*(difti-mu.den)*zeta.den),rep(0,p)))
  }
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(-2*t(G)%*%inverSigma.den%*%ri+2*t(t(beta.den)%*%t(G)%*%inverSigma.den%*%Xnewi))
  return(f)	
}


##caculate dlogfdmdthe1
caldlogfdmdthe1=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,mi.den,beta.den,zeta.den,A1.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){
    p=dim(Xi.den)[2]
    Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)
    G=cbind(rep(0,mi.den),exp(-(difti-mu.den)^2*(zeta.den))*(2*(difti-mu.den)*zeta.den),matrix(rep(0,mi.den*p),nrow=mi.den))
  }
  if (mi.den==1) {
    p=length(Xi.den)
    Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))
    G=t(c(0,exp(-(difti-mu.den)^2*(zeta.den))*(2*(difti-mu.den)*zeta.den),rep(0,p)))
  }
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(2*t(beta.den)%*%t(G)%*%A1.den%*%ri)
  return(f)	
}

##caculate dlogfdmdz
caldlogfdmdz=function(Xi.den,Yi.den,Ti.den,obsti.den,inverSigma.den,mi.den,beta.den,zeta.den,mu.den){	
  difti=Ti.den-obsti.den
  if (mi.den>1){
    p=dim(Xi.den)[2]
    Xnewi=cbind(rep(1,mi.den),exp(-(difti-mu.den)^2*(zeta.den)),Xi.den)
    E=cbind(rep(0,mi.den),exp(-(difti-mu.den)^2*(zeta.den))*(-(difti-mu.den)^2),matrix(rep(0,mi.den*p),nrow=mi.den))
    G=cbind(rep(0,mi.den),exp(-(difti-mu.den)^2*(zeta.den))*(2*(difti-mu.den)*zeta.den),matrix(rep(0,mi.den*p),nrow=mi.den))
    K=cbind(rep(0,mi.den),exp(-(difti-mu.den)^2*(zeta.den))*(-2*zeta.den*(difti-mu.den)^3+2*(difti-mu.den)),matrix(rep(0,mi.den*p),nrow=mi.den))
  }
  if (mi.den==1) {
    p=length(Xi.den)
    Xnewi=t(c(1,exp(-(difti-mu.den)^2*(zeta.den)),Xi.den))
    E=t(c(0,exp(-(difti-mu.den)^2*(zeta.den))*(-(difti-mu.den)^2),rep(0,p)))
    G=t(c(0,exp(-(difti-mu.den)^2*(zeta.den))*(2*(difti-mu.den)*zeta.den),rep(0,p)))
    K=t(c(0,exp(-(difti-mu.den)^2*(zeta.den))*(-2*zeta.den*(difti-mu.den)^3+2*(difti-mu.den)),rep(0,p)))
  }
  ri=Yi.den-Xnewi%*%beta.den
  f=-0.5*(-2*(t(beta.den)%*%t(K)%*%inverSigma.den%*%ri-t(beta.den)%*%t(G)%*%inverSigma.den%*%E%*%beta.den))
  return(f)	
}


lhood.complete=function(beta.lh,zeta.lh,mu.lh,theta.lh,Yfail.lh,Xfail.lh,Tfail.lh,obstfail.lh,mfail.lh){
  l=0
  if (sum(abs(theta.lh)>20)==0){
    for (i in 1:length(Tfail.lh)){
      Xi=Xfail.lh[(sum(mfail.lh[1:i])+1):(sum(mfail.lh[1:(i+1)])),]
      Yi=Yfail.lh[(sum(mfail.lh[1:i])+1):(sum(mfail.lh[1:(i+1)]))]
      mi=mfail.lh[i+1]
      Li=matrix(rep(1,,mi*mi),nrow=mi)
      
      Di=exp(theta.lh[2])
      sigmai=exp(theta.lh[1])
      rhoi=exp(theta.lh[3])/(1+exp(theta.lh[3]))
      obsti=obstfail.lh[(sum(mfail.lh[1:i])+1):(sum(mfail.lh[1:(i+1)]))]
      obsti.matrix=matrix(rep(obsti,length(obsti)),byrow=FALSE,nrow=length(obsti))
      Qi=rhoi^(abs(obsti.matrix-t(obsti.matrix)))*exp(theta.lh[4]+theta.lh[5]/2*(obsti.matrix+t(obsti.matrix)))
      Sigma=Di*Li+sigmai*diag(mi)+Qi
      
      if (is.na(rcond(Sigma))) {
        l=-Inf
      }
      if (is.na(rcond(Sigma))==FALSE) {
        if (rcond(Sigma)<10^(-10)) {
          l=-Inf
        }
        
        if (rcond(Sigma)>=10^(-10)) {
          inverSigma=solve(Sigma)
          obsti=obstfail.lh[(sum(mfail.lh[1:i])+1):(sum(mfail.lh[1:(i+1)]))]
          Ti=Tfail.lh[i]
          ltemp=callogden(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,Sigma.den=Sigma,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.lh,zeta.den=zeta.lh,mu.den=mu.lh)
          if(is.na(ltemp)) {ltemp=-Inf}
          if (ltemp>10^(300)) {ltemp=-Inf}
          l=l+ltemp
        }
      }
    }
  }
  if (sum(abs(theta.lh)>20)>0){l=-Inf}
  
  return(l)
}

NR.complete=function(beta.NR,zeta.NR,mu.NR,theta.NR,Yfail.NR,Xfail.NR,Tfail.NR,obstfail.NR,mfail.NR,p){
  dldm=0
  dldb=rep(0,2+p)
  dldthe1=0
  dldthe2=0
  dldthe3=0
  dldthe4=0
  dldthe5=0
  dldthe6=0
  dldz=0
  dldbdb=matrix(rep(0,(2+p)^2),nrow=2+p)
  dldthe1dthe1=0
  dldthe1dthe2=0
  dldthe1dthe3=0
  dldthe1dthe4=0
  dldthe1dthe5=0
  dldthe1dthe6=0
  dldthe2dthe2=0
  dldthe2dthe3=0
  dldthe2dthe4=0
  dldthe2dthe5=0
  dldthe2dthe6=0
  dldthe3dthe3=0
  dldthe3dthe4=0
  dldthe3dthe5=0
  dldthe3dthe6=0
  dldthe4dthe4=0
  dldthe4dthe5=0
  dldthe4dthe6=0
  dldthe5dthe5=0
  dldthe5dthe6=0
  dldthe6dthe6=0
  dldthe1db=rep(0,2+p)
  dldthe2db=rep(0,2+p)
  dldthe3db=rep(0,2+p)
  dldthe4db=rep(0,2+p)
  dldthe5db=rep(0,2+p)
  dldthe6db=rep(0,2+p)
  dldzdz=0
  dldzdb=rep(0,2+p)
  dldzdthe1=0
  dldzdthe2=0
  dldzdthe3=0
  dldzdthe4=0
  dldzdthe5=0
  dldzdthe6=0
  dldmdm=0
  dldmdb=rep(0,2+p)
  dldmdthe1=0
  dldmdthe2=0
  dldmdthe3=0
  dldmdthe4=0
  dldmdthe5=0
  dldmdthe6=0
  dldmdz=0
  
  for (i in 1:length(Tfail.NR)){
    
    Xi=Xfail.NR[(sum(mfail.NR[1:i])+1):(sum(mfail.NR[1:(i+1)])),]
    
    Yi=Yfail.NR[(sum(mfail.NR[1:i])+1):(sum(mfail.NR[1:(i+1)]))]
    mi=mfail.NR[i+1]
    obsti=obstfail.NR[(sum(mfail.NR[1:i])+1):(sum(mfail.NR[1:(i+1)]))]
    Ti=Tfail.NR[i]
    Li=matrix(rep(1,,mi*mi),nrow=mi)
    Di=exp(theta.NR[2])
    sigmai=exp(theta.NR[1])
    rhoi=exp(theta.NR[3])/(1+exp(theta.NR[3]))
    obsti.matrix=matrix(rep(obsti,length(obsti)),byrow=FALSE,nrow=length(obsti))
    Qi=rhoi^(abs(obsti.matrix-t(obsti.matrix)))*exp(theta.NR[4]+theta.NR[5]/2*(obsti.matrix+t(obsti.matrix)))
    T1i=(1-rhoi)*abs(obsti.matrix-t(obsti.matrix))
    T2i=(1-rhoi)^2*((obsti.matrix-t(obsti.matrix))^2)-abs(obsti.matrix-t(obsti.matrix))*rhoi*(1-rhoi)
    if (mi>1) {Ri=diag(obsti)}
    if (mi==1) {Ri=as.matrix(obsti)}
    
    Sigma=Di*Li+sigmai*diag(mi)+Qi
    time.NR=0
    while (rcond(Sigma)<10^(-10)&&time.NR<101) {
      diag(Sigma)=diag(Sigma)-10^(-5)
      time.NR=time.NR+1
    }
    inverSigma=solve(Sigma)
    dsigma1=sigmai*diag(mi)
    dsigma2=Di*Li
    dsigma3=T1i*Qi
    dsigma4=Qi
    dsigma5=(Ri%*%Qi+Qi%*%Ri)/2
    
    
    
    dsigma11=sigmai*diag(mi)
    dsigma12=matrix(rep(0,mi*mi),nrow=mi)
    dsigma13=matrix(rep(0,mi*mi),nrow=mi)
    dsigma14=matrix(rep(0,mi*mi),nrow=mi)
    dsigma15=matrix(rep(0,mi*mi),nrow=mi)
    #dsigma16=matrix(rep(0,mi*mi),nrow=mi)
    dsigma22=Di*Li
    dsigma23=matrix(rep(0,mi*mi),nrow=mi)
    dsigma24=matrix(rep(0,mi*mi),nrow=mi)
    dsigma25=matrix(rep(0,mi*mi),nrow=mi)
    #dsigma26=matrix(rep(0,mi*mi),nrow=mi)
    dsigma33=T2i*Qi
    dsigma34=T1i*Qi
    dsigma35=(Ri%*%dsigma3+dsigma3%*%Ri)/2
    #dsigma36=((Ri^2)%*%dsigma3+dsigma3%*%(Ri^2))/2
    dsigma44=Qi
    dsigma45=(Ri%*%Qi+Qi%*%Ri)/2
    #dsigma46=((Ri^2)%*%Qi+Qi%*%(Ri^2))/2
    dsigma55=((Ri^2)%*%Qi+2*(Ri%*%Qi%*%Ri)+Qi%*%(Ri^2))/4
    #dsigma56=((Ri^3)%*%Qi+Ri%*%Qi%*%(Ri^2)+(Ri^2)%*%Qi%*%Ri+Qi%*%(Ri^3))/4
    #dsigma66=((Ri^4)%*%Qi+2*((Ri^2)%*%Qi%*%(Ri^2))+Qi%*%(Ri^4))/4
    A1=inverSigma%*%dsigma1%*%inverSigma
    A2=inverSigma%*%dsigma2%*%inverSigma
    A3=inverSigma%*%dsigma3%*%inverSigma
    A4=inverSigma%*%dsigma4%*%inverSigma
    A5=inverSigma%*%dsigma5%*%inverSigma
    #A6=inverSigma%*%dsigma6%*%inverSigma
    dA11=-inverSigma%*%(dsigma1%*%inverSigma%*%dsigma1-dsigma11+dsigma1%*%inverSigma%*%dsigma1)%*%inverSigma
    dA12=-inverSigma%*%(dsigma2%*%inverSigma%*%dsigma1-dsigma12+dsigma1%*%inverSigma%*%dsigma2)%*%inverSigma
    dA13=-inverSigma%*%(dsigma3%*%inverSigma%*%dsigma1-dsigma13+dsigma1%*%inverSigma%*%dsigma3)%*%inverSigma
    dA14=-inverSigma%*%(dsigma4%*%inverSigma%*%dsigma1-dsigma14+dsigma1%*%inverSigma%*%dsigma4)%*%inverSigma
    dA15=-inverSigma%*%(dsigma5%*%inverSigma%*%dsigma1-dsigma15+dsigma1%*%inverSigma%*%dsigma5)%*%inverSigma
    #dA16=-inverSigma%*%(dsigma6%*%inverSigma%*%dsigma1-dsigma16+dsigma1%*%inverSigma%*%dsigma6)%*%inverSigma
    dA22=-inverSigma%*%(dsigma2%*%inverSigma%*%dsigma2-dsigma22+dsigma2%*%inverSigma%*%dsigma2)%*%inverSigma
    dA23=-inverSigma%*%(dsigma3%*%inverSigma%*%dsigma2-dsigma23+dsigma2%*%inverSigma%*%dsigma3)%*%inverSigma
    dA24=-inverSigma%*%(dsigma4%*%inverSigma%*%dsigma2-dsigma24+dsigma2%*%inverSigma%*%dsigma4)%*%inverSigma
    dA25=-inverSigma%*%(dsigma5%*%inverSigma%*%dsigma2-dsigma25+dsigma2%*%inverSigma%*%dsigma5)%*%inverSigma
    #dA26=-inverSigma%*%(dsigma6%*%inverSigma%*%dsigma2-dsigma26+dsigma2%*%inverSigma%*%dsigma6)%*%inverSigma
    dA33=-inverSigma%*%(dsigma3%*%inverSigma%*%dsigma3-dsigma33+dsigma3%*%inverSigma%*%dsigma3)%*%inverSigma
    dA34=-inverSigma%*%(dsigma4%*%inverSigma%*%dsigma3-dsigma34+dsigma3%*%inverSigma%*%dsigma4)%*%inverSigma
    dA35=-inverSigma%*%(dsigma5%*%inverSigma%*%dsigma3-dsigma35+dsigma3%*%inverSigma%*%dsigma5)%*%inverSigma
    #dA36=-inverSigma%*%(dsigma6%*%inverSigma%*%dsigma3-dsigma36+dsigma3%*%inverSigma%*%dsigma6)%*%inverSigma
    dA44=-inverSigma%*%(dsigma4%*%inverSigma%*%dsigma4-dsigma44+dsigma4%*%inverSigma%*%dsigma4)%*%inverSigma
    dA45=-inverSigma%*%(dsigma5%*%inverSigma%*%dsigma4-dsigma45+dsigma4%*%inverSigma%*%dsigma5)%*%inverSigma
    #dA46=-inverSigma%*%(dsigma6%*%inverSigma%*%dsigma4-dsigma46+dsigma4%*%inverSigma%*%dsigma6)%*%inverSigma
    dA55=-inverSigma%*%(dsigma5%*%inverSigma%*%dsigma5-dsigma55+dsigma5%*%inverSigma%*%dsigma5)%*%inverSigma
    #dA56=-inverSigma%*%(dsigma6%*%inverSigma%*%dsigma5-dsigma56+dsigma5%*%inverSigma%*%dsigma6)%*%inverSigma
    #dA66=-inverSigma%*%(dsigma6%*%inverSigma%*%dsigma6-dsigma66+dsigma6%*%inverSigma%*%dsigma6)%*%inverSigma
    
    
    dldm=dldm+caldlogfdm(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
    dldb=dldb+caldlogfdb(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
    dldthe1=dldthe1+caldlogfdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A1,dsigma1.den=dsigma1,mu.den=mu.NR)
    dldthe2=dldthe2+caldlogfdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A2,dsigma1.den=dsigma2,mu.den=mu.NR)
    dldthe3=dldthe3+caldlogfdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A3,dsigma1.den=dsigma3,mu.den=mu.NR)
    dldthe4=dldthe4+caldlogfdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A4,dsigma1.den=dsigma4,mu.den=mu.NR)
    dldthe5=dldthe5+caldlogfdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A5,dsigma1.den=dsigma5,mu.den=mu.NR)
    #dldthe6=dldthe6+caldlogfdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A6,dsigma1.den=dsigma6,mu.den=mu.NR)
    
    
    dldz=dldz+caldlogfdz(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
    dldbdb=dldbdb+caldlogfdbdb(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
    dldthe1dthe1=dldthe1dthe1+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA11,A1.den=A1,dsigma1.den=dsigma1,dsigma11.den=dsigma11,mu.den=mu.NR)
    dldthe1dthe2=dldthe1dthe2+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA12,A1.den=A1,dsigma1.den=dsigma2,dsigma11.den=dsigma12,mu.den=mu.NR)
    dldthe1dthe3=dldthe1dthe3+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA13,A1.den=A1,dsigma1.den=dsigma3,dsigma11.den=dsigma13,mu.den=mu.NR)
    dldthe1dthe4=dldthe1dthe4+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA14,A1.den=A1,dsigma1.den=dsigma4,dsigma11.den=dsigma14,mu.den=mu.NR)
    dldthe1dthe5=dldthe1dthe5+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA15,A1.den=A1,dsigma1.den=dsigma5,dsigma11.den=dsigma15,mu.den=mu.NR)
    #dldthe1dthe6=dldthe1dthe6+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA16,A1.den=A1,dsigma1.den=dsigma6,dsigma11.den=dsigma16,mu.den=mu.NR)
    
    dldthe2dthe2=dldthe2dthe2+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA22,A1.den=A2,dsigma1.den=dsigma2,dsigma11.den=dsigma22,mu.den=mu.NR)
    dldthe2dthe3=dldthe2dthe3+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA23,A1.den=A2,dsigma1.den=dsigma3,dsigma11.den=dsigma23,mu.den=mu.NR)
    dldthe2dthe4=dldthe2dthe4+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA24,A1.den=A2,dsigma1.den=dsigma4,dsigma11.den=dsigma24,mu.den=mu.NR)
    dldthe2dthe5=dldthe2dthe5+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA25,A1.den=A2,dsigma1.den=dsigma5,dsigma11.den=dsigma25,mu.den=mu.NR)
    #dldthe2dthe6=dldthe2dthe6+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA26,A1.den=A2,dsigma1.den=dsigma6,dsigma11.den=dsigma26,mu.den=mu.NR)
    
    dldthe3dthe3=dldthe3dthe3+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA33,A1.den=A3,dsigma1.den=dsigma3,dsigma11.den=dsigma33,mu.den=mu.NR)
    dldthe3dthe4=dldthe3dthe4+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA34,A1.den=A3,dsigma1.den=dsigma4,dsigma11.den=dsigma34,mu.den=mu.NR)
    dldthe3dthe5=dldthe3dthe5+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA35,A1.den=A3,dsigma1.den=dsigma5,dsigma11.den=dsigma35,mu.den=mu.NR)
    #dldthe3dthe6=dldthe3dthe6+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA36,A1.den=A3,dsigma1.den=dsigma6,dsigma11.den=dsigma36,mu.den=mu.NR)
    
    dldthe4dthe4=dldthe4dthe4+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA44,A1.den=A4,dsigma1.den=dsigma4,dsigma11.den=dsigma44,mu.den=mu.NR)
    dldthe4dthe5=dldthe4dthe5+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA45,A1.den=A4,dsigma1.den=dsigma5,dsigma11.den=dsigma45,mu.den=mu.NR)
    #dldthe4dthe6=dldthe4dthe6+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA46,A1.den=A4,dsigma1.den=dsigma6,dsigma11.den=dsigma46,mu.den=mu.NR)
    
    dldthe5dthe5=dldthe5dthe5+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA55,A1.den=A5,dsigma1.den=dsigma5,dsigma11.den=dsigma55,mu.den=mu.NR)
    #dldthe5dthe6=dldthe5dthe6+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA56,A1.den=A5,dsigma1.den=dsigma6,dsigma11.den=dsigma56,mu.den=mu.NR)
    
    #dldthe6dthe6=dldthe6dthe6+caldlogfdthe1dthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,dA11.den=dA66,A1.den=A6,dsigma1.den=dsigma6,dsigma11.den=dsigma66,mu.den=mu.NR)
    
    
    
    dldthe1db=dldthe1db+caldlogfdthe1db(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A1,mu.den=mu.NR)
    dldthe2db=dldthe2db+caldlogfdthe1db(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A2,mu.den=mu.NR)
    dldthe3db=dldthe3db+caldlogfdthe1db(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A3,mu.den=mu.NR)
    dldthe4db=dldthe4db+caldlogfdthe1db(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A4,mu.den=mu.NR)
    dldthe5db=dldthe5db+caldlogfdthe1db(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A5,mu.den=mu.NR)
    #dldthe6db=dldthe6db+caldlogfdthe1db(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A6,mu.den=mu.NR)
    
    dldzdz=dldzdz+caldlogfdzdz(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
    dldzdb=dldzdb+caldlogfdzdb(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
    dldzdthe1=dldzdthe1+caldlogfdzdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A1,mu.den=mu.NR)
    dldzdthe2=dldzdthe2+caldlogfdzdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A2,mu.den=mu.NR)
    dldzdthe3=dldzdthe3+caldlogfdzdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A3,mu.den=mu.NR)
    dldzdthe4=dldzdthe4+caldlogfdzdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A4,mu.den=mu.NR)
    dldzdthe5=dldzdthe5+caldlogfdzdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A5,mu.den=mu.NR)
    #dldzdthe6=dldzdthe6+caldlogfdzdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A6,mu.den=mu.NR)
    
    dldmdm=dldmdm+caldlogfdmdm(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
    dldmdb=dldmdb+caldlogfdmdb(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
    dldmdthe1=dldmdthe1+caldlogfdmdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A1,mu.den=mu.NR)
    dldmdthe2=dldmdthe2+caldlogfdmdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A2,mu.den=mu.NR)
    dldmdthe3=dldmdthe3+caldlogfdmdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A3,mu.den=mu.NR)
    dldmdthe4=dldmdthe4+caldlogfdmdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A4,mu.den=mu.NR)
    dldmdthe5=dldmdthe5+caldlogfdmdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A5,mu.den=mu.NR)
    #dldmdthe6=dldmdthe6+caldlogfdmdthe1(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,A1.den=A6,mu.den=mu.NR)
    
    dldmdz=dldmdz+caldlogfdmdz(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
  }
  
  S=c(dldb,dldz,dldm,dldthe1,dldthe2,dldthe3,dldthe4,dldthe5)
  Hbeta=cbind(dldbdb,dldzdb,dldmdb,dldthe1db,dldthe2db,dldthe3db,dldthe4db,dldthe5db)
  Hzeta=cbind(t(dldzdb),dldzdz,dldmdz,dldzdthe1,dldzdthe2,dldzdthe3,dldzdthe4,dldzdthe5)
  Hmu=cbind(t(dldmdb),dldmdz,dldmdm,dldmdthe1,dldmdthe2,dldmdthe3,dldmdthe4,dldmdthe5)
  Htheta=cbind(rbind(t(dldthe1db),t(dldthe2db),t(dldthe3db),t(dldthe4db),t(dldthe5db)),c(dldzdthe1,dldzdthe2,dldzdthe3,dldzdthe4,dldzdthe5),c(dldmdthe1,dldmdthe2,dldmdthe3,dldmdthe4,dldmdthe5),matrix(c(dldthe1dthe1,dldthe1dthe2,dldthe1dthe3,dldthe1dthe4,dldthe1dthe5,dldthe1dthe2,dldthe2dthe2,dldthe2dthe3,dldthe2dthe4,dldthe2dthe5,dldthe1dthe3,dldthe2dthe3,dldthe3dthe3,dldthe3dthe4,dldthe3dthe5,dldthe1dthe4,dldthe2dthe4,dldthe3dthe4,dldthe4dthe4,dldthe4dthe5,dldthe1dthe5,dldthe2dthe5,dldthe3dthe5,dldthe4dthe5,dldthe5dthe5),byrow=T,nrow=5))
  H=rbind(Hbeta,Hzeta,Hmu,Htheta)
  SH=cbind(S,H)
  return(SH)
}





Newton.complete=function(intbeta,intzeta,intmu,inttheta,Yfail.newton,Xfail.newton,Tfail.newton,obstfail.newton,mfail.newton,p,maxstep=501){
  lnew=lhood.complete(intbeta,intzeta,intmu,inttheta,Yfail.newton,Xfail.newton,Tfail.newton,obstfail.newton,mfail.newton)
  #print(lnew)
  
  dif=10^5
  step=0
  while (abs(dif)>10^(-3)&&step<maxstep){
    lold=lnew
    SHnew=NR.complete(intbeta,intzeta,intmu,inttheta,Yfail.newton,Xfail.newton,Tfail.newton,obstfail.newton,mfail.newton,p)
    Snew=SHnew[,1]
    Hnew=SHnew[,-1]
    
    Hnew=Hnew-max(0,max(Re(eigen(Hnew)$values))*1.01)*diag(6+p+3)
    
    
    time.newton=0
    while (is.numeric(try(solve(Hnew),silent=TRUE))==FALSE&&time.newton<21) {
      diag(Hnew)=diag(Hnew)-10^(-5)
      time.newton=time.newton+1
    }
    if (is.numeric(try(solve(Hnew),silent=TRUE))){
      delta=-solve(Hnew)%*%Snew
      
      lnew=lhood.complete(intbeta+delta[1:(2+p)],intzeta+delta[3+p],intmu+delta[4+p],inttheta+delta[(5+p):(length(delta))],Yfail.newton,Xfail.newton,Tfail.newton,obstfail.newton,mfail.newton)
      #print(lnew,digits=16)
      dif=sum(abs(delta))
      while (lnew<lold){
        delta=delta/2
        #print(delta)
        lnew=lhood.complete(intbeta+delta[1:(2+p)],intzeta+delta[3+p],intmu+delta[4+p],inttheta+delta[(5+p):(length(delta))],Yfail.newton,Xfail.newton,Tfail.newton,obstfail.newton,mfail.newton)
        dif=sum(abs(delta))
        #print(lnew,digits=16)
        #print(intbeta)
        #print(intzeta)
        #print(inttheta)
      }
      intbeta=intbeta+delta[1:(2+p)]
      intzeta=intzeta+delta[3+p]
      intmu=intmu+delta[4+p]
      inttheta=inttheta+delta[(5+p):(length(delta))]
      dif=sum(abs(delta))
      #print(c(step,dif,intbeta,intzeta,intmu))
      #print(intzeta)
      #print(inttheta)
      
      step=step+1
    }
    if (is.numeric(try(solve(Hnew),silent=TRUE))==FALSE){
      step=maxstep
    }
  }
  esti=c(intbeta,intzeta,intmu,inttheta)
  SHnew=NR.complete(intbeta,intzeta,intmu,inttheta,Yfail.newton,Xfail.newton,Tfail.newton,obstfail.newton,mfail.newton,p)
  estiSH=cbind(esti,SHnew)
  return(list(esti=estiSH,stepre=step,like=lnew))
}




#################################
######two stage #################
#################################

##cox jump
est.cox=function(CT.cox,xfail.cox,Delta.cox,xcensor.cox,p.cox,Tfail.cox,mfail.cox,mcensor.cox){
  
  n.cox=length(CT.cox)
  num.fail=sum(Delta.cox)
  x.cox=rbind(xfail.cox,xcensor.cox)
  m.cox=c(mfail.cox,mcensor.cox[-1])
  xunique=matrix(NA,ncol=p.cox,nrow=length(CT.cox))
  for (i in 1:n.cox){
    xunique[i,]=x.cox[sum(m.cox[1:i])+1,]
  }
  xcensor.unique=matrix(NA,ncol=p.cox,nrow=n.cox-num.fail)
  for (i in 1:(n.cox-num.fail)){
    xcensor.unique[i,]=xcensor.cox[sum(mcensor.cox[1:i])+1,]
  }
  
  X1=xunique[,1]
  X2=xunique[,2]
  X3=xunique[,3]
  X4=xunique[,4]
  
  
  
  #fit <- coxph(Surv(CT.cox, Delta.cox) ~X1+X2+X3+X4 ,method="breslow")
  fit <- coxph(Surv(CT.cox, Delta.cox) ~X1+X2+X3+X4 ,method="breslow")
  jump=matrix(rep(0,length(unique(Tfail.cox))*(n.cox-num.fail)),nrow=n.cox-num.fail)
  for (i in 1:(n.cox-num.fail)){
    jump[i,]=summary(survfit(fit, newdata=data.frame(X1=xcensor.unique[i,1],X2=xcensor.unique[i,2],X3=xcensor.unique[i,3],X4=xcensor.unique[i,4])))$surv
  } 
  weight_temp=cbind(rep(1,n.cox-num.fail),jump[,-(length(unique(Tfail.cox)))])-jump
  CTcensor.cox=CT.cox[Delta.cox==0]
  
  indicator=matrix(NA,nrow=n.cox-num.fail,ncol=length(unique(Tfail.cox)))
  for (i in 1:(n.cox-num.fail)){
    indicator[i,]=(unique(Tfail.cox)>CTcensor.cox[i])
  }
  weight=weight_temp*indicator
  return(list(weight=weight))
}


##cox jump



lhood=function(beta.lh,zeta.lh,mu.lh,theta.lh,weight.lh,Ycensor.lh,Yfail.lh,Xcensor.lh,Xfail.lh,Tfail.lh,CT.lh,obstcensor.lh,obstfail.lh,mcensor.lh,mfail.lh){
  l=0
  n=length(mcensor.lh)+length(mfail.lh)-2
  if (sum(abs(theta.lh)>20)==0){
    for (i in 1:length(Tfail.lh)){
      Xi=Xfail.lh[(sum(mfail.lh[1:i])+1):(sum(mfail.lh[1:(i+1)])),]
      Yi=Yfail.lh[(sum(mfail.lh[1:i])+1):(sum(mfail.lh[1:(i+1)]))]
      mi=mfail.lh[i+1]
      Li=matrix(rep(1,,mi*mi),nrow=mi)
      
      Di=exp(theta.lh[2])
      sigmai=exp(theta.lh[1])
      rhoi=exp(theta.lh[3])/(1+exp(theta.lh[3]))
      obsti=obstfail.lh[(sum(mfail.lh[1:i])+1):(sum(mfail.lh[1:(i+1)]))]
      obsti.matrix=matrix(rep(obsti,length(obsti)),byrow=FALSE,nrow=length(obsti))
      Qi=rhoi^(abs(obsti.matrix-t(obsti.matrix)))*exp(theta.lh[4]+theta.lh[5]/2*(obsti.matrix+t(obsti.matrix)))
      Sigma=Di*Li+sigmai*diag(mi)+Qi
      
      if (sum(abs(Sigma))==Inf){l=-Inf}
      if (sum(abs(Sigma))<Inf){
        if (rcond(Sigma)<10^(-10)) {
          l=-Inf
        }
        if (rcond(Sigma)>=10^(-10)) {
          Ti=Tfail.lh[i]
          inverSigma=solve(Sigma)
          
          ltemp=callogden(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,Sigma.den=Sigma,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.lh,zeta.den=zeta.lh,mu.den=mu.lh)
          if(is.na(ltemp)) {ltemp=-Inf}
          #if (ltemp>10^(300)) {ltemp=-Inf}
          l=l+ltemp
        }
      }
    }
    fden=matrix(rep(0,(length(unique(Tfail.lh)))*(n-length(Tfail.lh))),nrow=n-length(Tfail.lh))
    for (i in 1:(n-length(Tfail.lh))){
      mi=mcensor.lh[i+1]
      Yi=Ycensor.lh[(sum(mcensor.lh[1:i])+1):(sum(mcensor.lh[1:(i+1)]))]
      Xi=Xcensor.lh[(sum(mcensor.lh[1:i])+1):(sum(mcensor.lh[1:(i+1)])),]
      Li=matrix(rep(1,,mi*mi),nrow=mi)
      Di=exp(theta.lh[2])
      sigmai=exp(theta.lh[1])
      rhoi=exp(theta.lh[3])/(1+exp(theta.lh[3]))
      obsti=obstcensor.lh[(sum(mcensor.lh[1:i])+1):(sum(mcensor.lh[1:(i+1)]))]
      obsti.matrix=matrix(rep(obsti,length(obsti)),byrow=FALSE,nrow=length(obsti))
      Qi=rhoi^(abs(obsti.matrix-t(obsti.matrix)))*exp(theta.lh[4]+theta.lh[5]/2*(obsti.matrix+t(obsti.matrix)))
      Sigma=Di*Li+sigmai*diag(mi)+Qi
      
      if (sum(abs(Sigma))==Inf){l=-Inf}
      if (sum(abs(Sigma))<Inf){
        if (rcond(Sigma)<10^(-10)) {
          l=-Inf
        }
        if (rcond(Sigma)>=10^(-10)) {
          if (sum(weight.lh[i,])>10^(-300)){
            inverSigma=solve(Sigma)
            
            Tfail1.lh=as.matrix(c(unique(Tfail.lh)))
            fden[i,]=apply(Tfail1.lh,1,calden,Yi.den=Yi,Xi.den=Xi,obsti.den=obsti,Sigma.den=Sigma,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.lh,zeta.den=zeta.lh,mu.den=mu.lh)
            ltemp=log(sum(weight.lh[i,]*fden[i,]))
            if(is.na(ltemp)) {ltemp=-Inf}
            if (ltemp>10^(300)) {ltemp=-Inf}
            l=l+ltemp
          }		
        }	
      }
    }
  }
  if (sum(abs(theta.lh)>20)>0){l=-Inf}	
  return(l)
}




NR=function(beta.NR,zeta.NR,mu.NR,theta.NR,weight.NR,Ycensor.NR,Yfail.NR,Xcensor.NR,Xfail.NR,Tfail.NR,CT.NR,obstcensor.NR,obstfail.NR,mcensor.NR,mfail.NR,p.NR){
  n=length(mcensor.NR)+length(mfail.NR)-2
  dldm=0
  dldb=rep(0,2+p.NR)
  
  dldz=0
  dldbdb=matrix(rep(0,(2+p.NR)^2),nrow=2+p.NR)
  
  dldzdz=0
  dldzdb=rep(0,2+p.NR)
  
  dldmdb=rep(0,2+p.NR)
  dldmdz=0
  dldmdm=0
  
  fden=matrix(NA,nrow=(n-length(Tfail.NR)),ncol=length(unique(Tfail.NR)))
  dlogfdbden=array(NA,c(n-length(Tfail.NR),p.NR+2,length(unique(Tfail.NR))))
  dlogfdmden=matrix(NA,nrow=(n-length(Tfail.NR)),ncol=length(unique(Tfail.NR)))
  dlogfdzden=matrix(NA,nrow=(n-length(Tfail.NR)),ncol=length(unique(Tfail.NR)))
  dlogfdbdbden=array(NA,c(n-length(Tfail.NR),(p.NR+2)^2,length(unique(Tfail.NR))))
  
  dlogfdzdzden=matrix(NA,nrow=(n-length(Tfail.NR)),ncol=length(unique(Tfail.NR)))
  dlogfdzdbden=array(NA,c(n-length(Tfail.NR),p.NR+2,length(unique(Tfail.NR))))
  dlogfdmdzden=matrix(NA,nrow=(n-length(Tfail.NR)),ncol=length(unique(Tfail.NR)))
  dlogfdmdmden=matrix(NA,nrow=(n-length(Tfail.NR)),ncol=length(unique(Tfail.NR)))
  dlogfdmdbden=array(NA,c(n-length(Tfail.NR),p.NR+2,length(unique(Tfail.NR))))
  
  
  
  for (i in 1:length(Tfail.NR)){
    
    Xi=Xfail.NR[(sum(mfail.NR[1:i])+1):(sum(mfail.NR[1:(i+1)])),]
    
    Yi=Yfail.NR[(sum(mfail.NR[1:i])+1):(sum(mfail.NR[1:(i+1)]))]
    mi=mfail.NR[i+1]
    Li=matrix(rep(1,,mi*mi),nrow=mi)
    Di=exp(theta.NR[2])
    sigmai=exp(theta.NR[1])
    rhoi=exp(theta.NR[3])/(1+exp(theta.NR[3]))
    obsti=obstfail.NR[(sum(mfail.NR[1:i])+1):(sum(mfail.NR[1:(i+1)]))]
    obsti.matrix=matrix(rep(obsti,length(obsti)),byrow=FALSE,nrow=length(obsti))
    Qi=rhoi^(abs(obsti.matrix-t(obsti.matrix)))*exp(theta.NR[4]+theta.NR[5]/2*(obsti.matrix+t(obsti.matrix)))		
    Sigma=Di*Li+sigmai*diag(mi)+Qi
    
    if (sum(abs(Sigma))==Inf){l=-Inf}
    if (sum(abs(Sigma))<Inf){
      time.NR=0
      while (rcond(Sigma)<10^(-10)&&time.NR<101) {
        diag(Sigma)=diag(Sigma)-10^(-5)
        time.NR=time.NR+1
      }
      inverSigma=solve(Sigma)
      obsti=obstfail.NR[(sum(mfail.NR[1:i])+1):(sum(mfail.NR[1:(i+1)]))]
      Ti=Tfail.NR[i]
      
      
      
      dldm=dldm+caldlogfdm(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
      dldb=dldb+caldlogfdb(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
      
      dldz=dldz+caldlogfdz(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
      dldbdb=dldbdb+caldlogfdbdb(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
      
      
      dldzdz=dldzdz+caldlogfdzdz(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
      dldzdb=dldzdb+caldlogfdzdb(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
      
      dldmdm=dldmdm+caldlogfdmdm(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
      dldmdb=dldmdb+caldlogfdmdb(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
      
      dldmdz=dldmdz+caldlogfdmdz(Xi.den=Xi,Yi.den=Yi,Ti.den=Ti,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
    }
  }
  
  for (i in 1:(n-length(Tfail.NR))){
    if (sum(weight.NR[i,])>10^(-300)){
      mi=mcensor.NR[i+1]
      Yi=Ycensor.NR[(sum(mcensor.NR[1:i])+1):(sum(mcensor.NR[1:(i+1)]))]
      Xi=Xcensor.NR[(sum(mcensor.NR[1:i])+1):(sum(mcensor.NR[1:(i+1)])),]
      obsti=obstcensor.NR[(sum(mcensor.NR[1:i])+1):(sum(mcensor.NR[1:(i+1)]))]
      Li=matrix(rep(1,,mi*mi),nrow=mi)
      Di=exp(theta.NR[2])
      sigmai=exp(theta.NR[1])
      rhoi=exp(theta.NR[3])/(1+exp(theta.NR[3]))
      
      obsti.matrix=matrix(rep(obsti,length(obsti)),byrow=FALSE,nrow=length(obsti))
      Qi=rhoi^(abs(obsti.matrix-t(obsti.matrix)))*exp(theta.NR[4]+theta.NR[5]/2*(obsti.matrix+t(obsti.matrix)))		
      Sigma=Di*Li+sigmai*diag(mi)+Qi
      
      if (sum(abs(Sigma))==Inf){l=-Inf}
      if (sum(abs(Sigma))<Inf){
        time.NR=0
        while (rcond(Sigma)<10^(-15)&&time.NR<101) {
          diag(Sigma)=diag(Sigma)+10^(-5)
          time.NR=time.NR+1
        }
        inverSigma=solve(Sigma)
        Tfail1.NR=as.matrix(c(unique(Tfail.NR)))
        
        fden[i,]=apply(Tfail1.NR,1,calden,Xi.den=Xi,Yi.den=Yi,obsti.den=obsti,Sigma.den=Sigma,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
        dlogfdbden[i,,]=apply(Tfail1.NR,1,caldlogfdb,Xi.den=Xi,Yi.den=Yi,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
        dlogfdmden[i,]=apply(Tfail1.NR,1,caldlogfdm,Xi.den=Xi,Yi.den=Yi,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
        dlogfdzden[i,]=apply(Tfail1.NR,1,caldlogfdz,Xi.den=Xi,Yi.den=Yi,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
        dlogfdbdbden[i,,]=apply(Tfail1.NR,1,caldlogfdbdb,Xi.den=Xi,Yi.den=Yi,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
        
        dlogfdzdzden[i,]=apply(Tfail1.NR,1,caldlogfdzdz,Xi.den=Xi,Yi.den=Yi,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
        dlogfdzdbden[i,,]=apply(Tfail1.NR,1,caldlogfdzdb,Xi.den=Xi,Yi.den=Yi,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
        
        dlogfdmdmden[i,]=apply(Tfail1.NR,1,caldlogfdmdm,Xi.den=Xi,Yi.den=Yi,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
        dlogfdmdzden[i,]=apply(Tfail1.NR,1,caldlogfdmdz,Xi.den=Xi,Yi.den=Yi,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
        dlogfdmdbden[i,,]=apply(Tfail1.NR,1,caldlogfdmdb,Xi.den=Xi,Yi.den=Yi,obsti.den=obsti,inverSigma.den=inverSigma,mi.den=mi,beta.den=beta.NR,zeta.den=zeta.NR,mu.den=mu.NR)
        
        denominator=sum(weight.NR[i,]*fden[i,])
        if (denominator>=10^(-300)){
          const=diag(weight.NR[i,]*fden[i,])
          dldb=dldb+rowSums(dlogfdbden[i,,]%*%const)/denominator
          
          dldz=dldz+sum(dlogfdzden[i,]*weight.NR[i,]*fden[i,])/denominator
          dldm=dldm+sum(dlogfdmden[i,]*weight.NR[i,]*fden[i,])/denominator
          dldbdb=dldbdb+(denominator*(matrix(rowSums(dlogfdbdbden[i,,]%*%const),byrow=TRUE,nrow=p.NR+2)+dlogfdbden[i,,]%*%const%*%t(dlogfdbden[i,,]))-rowSums(dlogfdbden[i,,]%*%const)%*%t(rowSums(dlogfdbden[i,,]%*%const)))/(denominator^2)
          
          dldzdz=dldzdz+(denominator*(sum(dlogfdzdzden[i,]*weight.NR[i,]*fden[i,])+sum(dlogfdzden[i,]*dlogfdzden[i,]*weight.NR[i,]*fden[i,]))-sum(dlogfdzden[i,]*weight.NR[i,]*fden[i,])^2)/(denominator^2)
          dldzdb=dldzdb+(denominator*(rowSums(dlogfdzdbden[i,,]%*%const)+rowSums(dlogfdbden[i,,]%*%diag(weight.NR[i,]*fden[i,]*dlogfdzden[i,])))-sum(weight.NR[i,]*fden[i,]*dlogfdzden[i,])*rowSums(dlogfdbden[i,,]%*%const))/(denominator^2)
          
          dldmdm=dldmdm+(denominator*(sum(dlogfdmdmden[i,]*weight.NR[i,]*fden[i,])+sum(dlogfdmden[i,]*dlogfdmden[i,]*weight.NR[i,]*fden[i,]))-sum(dlogfdmden[i,]*weight.NR[i,]*fden[i,])^2)/(denominator^2)
          dldmdz=dldmdz+(denominator*(sum(dlogfdmdzden[i,]*weight.NR[i,]*fden[i,])+sum(dlogfdmden[i,]*dlogfdzden[i,]*weight.NR[i,]*fden[i,]))-sum(dlogfdmden[i,]*weight.NR[i,]*fden[i,])*sum(dlogfdzden[i,]*weight.NR[i,]*fden[i,]))/(denominator^2)
          dldmdb=dldmdb+(denominator*(rowSums(dlogfdmdbden[i,,]%*%const)+rowSums(dlogfdbden[i,,]%*%diag(weight.NR[i,]*fden[i,]*dlogfdmden[i,])))-sum(weight.NR[i,]*fden[i,]*dlogfdmden[i,])*rowSums(dlogfdbden[i,,]%*%const))/(denominator^2)
        }
      }
    }
  }
  S=c(dldb,dldz,dldm)
  Hbeta=cbind(dldbdb,dldzdb,dldmdb)
  Hzeta=cbind(t(dldzdb),dldzdz,dldmdz)
  Hmu=cbind(t(dldmdb),dldmdz,dldmdm)
  H=rbind(Hbeta,Hzeta,Hmu)
  SH=cbind(S,H)
  return(SH)
}


Newton=function(intbeta,intzeta,intmu,inttheta,Ycensor.newton,Yfail.newton,Xcensor.newton,Xfail.newton,Tfail.newton,CT.newton,obstcensor.newton,obstfail.newton,mcensor.newton,mfail.newton,Delta.newton,p.newton,maxstep=101,Xcensor.cox.newton,Xfail.cox.newton){
  weight.newton=est.cox(CT.cox=CT.newton,xfail.cox=Xfail.cox.newton,Delta.cox=Delta.newton,xcensor.cox=Xcensor.cox.newton,p.cox=dim(Xfail.cox.newton)[2],Tfail.cox=Tfail.newton,mfail.cox=mfail.newton,mcensor.cox=mcensor.newton)$weight
  lnew=lhood(intbeta,intzeta,intmu,inttheta,weight.newton,Ycensor.newton,Yfail.newton,Xcensor.newton,Xfail.newton,Tfail.newton,CT.newton,obstcensor.newton,obstfail.newton,mcensor.newton,mfail.newton)
  #print(lnew)
  
  dif=10^5
  step=0
  while (abs(dif)>10^(-5)&&step<maxstep){
    lold=lnew
    SHnew=NR(intbeta,intzeta,intmu,inttheta,weight.newton,Ycensor.newton,Yfail.newton,Xcensor.newton,Xfail.newton,Tfail.newton,CT.newton,obstcensor.newton,obstfail.newton,mcensor.newton,mfail.newton,p.newton)
    Snew=SHnew[,1]
    Hnew=SHnew[,-1]
    
    Hnew=Hnew-max(0,max(eigen(Hnew)$values)*1.01)*diag(4+p.newton)
    
    time.newton=0
    #while (rcond(Hnew)<10^(-10)&&time.newton<21) {
    while (is.numeric(try(solve(Hnew),silent=TRUE))==FALSE&&time.newton<21) {
      diag(Hnew)=diag(Hnew)-10^(-5)
      time.newton=time.newton+1
    }
    if (is.numeric(try(solve(Hnew),silent=TRUE))){
      delta=-solve(Hnew)%*%Snew
      #print(delta)
      lnew=lhood(intbeta+delta[1:(2+p.newton)],intzeta+delta[3+p.newton],intmu+delta[4+p.newton],inttheta,weight.newton,Ycensor.newton,Yfail.newton,Xcensor.newton,Xfail.newton,Tfail.newton,CT.newton,obstcensor.newton,obstfail.newton,mcensor.newton,mfail.newton)
      #print(lnew,digits=16)
      dif=sum(abs(delta))
      while (lnew<lold){
        delta=delta/2
        #print(delta)
        lnew=lhood(intbeta+delta[1:(2+p.newton)],intzeta+delta[3+p.newton],intmu+delta[4+p.newton],inttheta,weight.newton,Ycensor.newton,Yfail.newton,Xcensor.newton,Xfail.newton,Tfail.newton,CT.newton,obstcensor.newton,obstfail.newton,mcensor.newton,mfail.newton)
        dif=sum(abs(delta))
        #print(lnew,digits=16)
        #print(intbeta)
        #print(intzeta)
        #print(inttheta)
      }
      intbeta=intbeta+delta[1:(2+p.newton)]
      intzeta=intzeta+delta[3+p.newton]
      intmu=intmu+delta[4+p.newton]
      #inttheta=inttheta+delta[(4+p.newton):(length(delta))]
      #print(intbeta)
      #print(intzeta)
      #print(inttheta)
      dif=sum(abs(delta))
      step=step+1
    }
    if (is.numeric(try(solve(Hnew),silent=TRUE))==FALSE){
      step=maxstep
    }
  }
  esti=c(intbeta,intzeta,intmu)
  SHnew=NR(intbeta,intzeta,intmu,inttheta,weight.newton,Ycensor.newton,Yfail.newton,Xcensor.newton,Xfail.newton,Tfail.newton,CT.newton,obstcensor.newton,obstfail.newton,mcensor.newton,mfail.newton,p.newton)
  estiSH=cbind(esti,SHnew)
  print(delta)
  return(list(esti=estiSH,stepre=step,like=lnew))
}


bootstrap=function(data1.boot,data2.boot,intbeta.boot,intzeta.boot,intmu.boot,inttheta.boot,n.boot,p.boot,pcox.boot){
  
  
  resample=sample(1:n.boot,replace=TRUE)
  data1.boot2=data1.boot[data1.boot[,p.boot+pcox.boot+3]==resample[1],]
  data2.boot2=data2.boot[data2.boot[,4]==resample[1],]
  
  for (i in 2:n.boot){
    data1.boot2=rbind(data1.boot2,data1.boot[data1.boot[,p.boot+pcox.boot+3]==resample[i],])
    data2.boot2=rbind(data2.boot2,data2.boot[data2.boot[,4]==resample[i],])
    
  }
  y.fail.boot=data1.boot2[data1.boot2[,p.boot+pcox.boot+4]==1,1]
  x.fail.boot=data1.boot2[data1.boot2[,p.boot+pcox.boot+4]==1,(2:(p.boot+1))]
  obst.fail.boot=data1.boot2[data1.boot2[,p.boot+pcox.boot+4]==1,(p.boot+2)]
  x.fail.cox.boot=data1.boot2[data1.boot2[,p.boot+pcox.boot+4]==1,((p.boot+3):(p.boot+pcox.boot+2))]
  y.censor.boot=data1.boot2[data1.boot2[,p.boot+pcox.boot+4]==0,1]
  x.censor.boot=data1.boot2[data1.boot2[,p.boot+pcox.boot+4]==0,(2:(p.boot+1))]
  obst.censor.boot=data1.boot2[data1.boot2[,p.boot+pcox.boot+4]==0,(p.boot+2)]
  x.censor.cox.boot=data1.boot2[data1.boot2[,p.boot+pcox.boot+4]==0,((p.boot+3):(p.boot+pcox.boot+2))]
  m.fail.boot=c(0,data2.boot2[data2.boot2[,3]==1,1])
  m.censor.boot=c(0,data2.boot2[data2.boot2[,3]==0,1])
  CT.boot=data2.boot2[,2]
  Delta.boot=data2.boot2[,3]
  T.fail.boot=data2.boot2[data2.boot2[,3]==1,2]
  ordertemp1=order(T.fail.boot)
  T.fail1.boot=T.fail.boot[ordertemp1]
  T.fail1.boot=unique(T.fail1.boot)
  #complete case
  comtemp0=Newton.complete(intbeta=intbeta.boot,intzeta=intzeta.boot,intmu=intmu.boot,inttheta=inttheta.boot,Yfail.newton=y.fail.boot,Xfail.newton=x.fail.boot,Tfail.newton=T.fail.boot,obstfail.newton=obst.fail.boot,mfail.newton=m.fail.boot,p=p.boot)
  result.complete.boot=comtemp0$esti[,1]
  step.complete.boot=comtemp0$stepre
  if (step.complete.boot<501){
    #two stage
    rtemp1=Newton(intbeta=result.complete.boot[1:(p.boot+2)],intzeta=result.complete.boot[p.boot+3],intmu=result.complete.boot[p.boot+4],
                  inttheta=result.complete.boot[(p.boot+5):length(result.complete.boot)],Ycensor.newton=y.censor.boot,Yfail.newton=y.fail.boot,Xcensor.newton=x.censor.boot,
                  Xfail.newton=x.fail.boot,Tfail.newton=T.fail.boot,CT.newton=CT.boot,obstcensor.newton=obst.censor.boot,obstfail.newton=obst.fail.boot,mcensor.newton=m.censor.boot,
                  mfail.newton=m.fail.boot,Delta.newton=Delta.boot,p.newton=p.boot,Xcensor.cox.newton=x.censor.cox.boot,Xfail.cox.newton=x.fail.cox.boot)
    
    esti.like1.boot=rtemp1$esti[,1]
    step.esti.boot=rtemp1$stepre
    if (step.esti.boot<101) {return(list(esti=esti.like1.boot,step.esti=step.esti.boot,complete=result.complete.boot,step.complete=step.complete.boot))}
    if (step.esti.boot==101) {return(list(esti="error",step.esti="error",complete="error",step.complete="error"))}
  }
  if (step.complete.boot==101){return(list(esti="error",step.esti="error",complete="error",step.complete="error"))}
  
  
}
